﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace NorthwindLibrary
{
    public class ContextFactory
    {
        public static NorthwindOAEntityDiagrams ObtainContext()
        {
            NorthwindOAEntityDiagrams context = null;

            string key = Thread.CurrentContext.ContextID.ToString();

            LocalDataStoreSlot slot = Thread.GetNamedDataSlot(key);
            if (slot != null)
            {
                context = (NorthwindOAEntityDiagrams)Thread.GetData(slot);
            }
            if (context == null)
            {
                context = new NorthwindOAEntityDiagrams();
                if (slot == null)
                {
                    slot = Thread.AllocateNamedDataSlot(key);
                }
                Thread.SetData(slot, context);
            }
            return context;

        }
    }
}
