﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using NorthwindLibrary;
using Telerik.WinControls.UI;

namespace WinFormsApplication
{
    public partial class CategoryForm : Form
    {
        public CategoryForm()
        {
            this.InitializeComponent();
        }

        public Category SelectedCategory
        {
            get
            {
                if (this.CategoryRadGridView.CurrentRow == null)
                {
                    return null;
                }
                return this.CategoryRadGridView.CurrentRow.DataBoundItem as Category;
            }
        }

        public IEnumerable<Category> CategorySource
        {
            get
            {
                return this.CategoryBindingSource.DataSource as IEnumerable<Category>;
            }
            set 
            {
                this.CategoryBindingSource.DataSource = value;
                this.CategoryRadGridView.DataSource = this.CategoryBindingSource;
            }
        }

        public event ListChangedEventHandler DataSourceCollectionChanged
        {
            add
            {
                this.CategoryBindingSource.ListChanged += value;
            }
            remove
            {
                this.CategoryBindingSource.ListChanged -= value;
            }
        }
   
        public event EventHandler SaveChangesButtonClicked
        {
            add
            {
                this.SaveChangesButton.Click += value;
            }
            remove
            {
                this.SaveChangesButton.Click -= value;
            }
        }

        public event GridViewCollectionChangingEventHandler RowsChanging
        {
            add
            {
                this.CategoryRadGridView.RowsChanging += value;
            }
            remove
            {
                this.CategoryRadGridView.RowsChanging -= value;
            }
        }

        public event FormClosedEventHandler CategoryFormClosed
        {
            add
            {
                this.FormClosed += value;
            }
            remove
            {
                this.FormClosed -= value;
            }
        }

        public void ConfigureGrid()
        {
            this.CategoryRadGridView.Columns[0].IsVisible = false; 
            int numberOfColumns = this.CategoryRadGridView.Columns.Count;
            this.CategoryRadGridView.Columns[numberOfColumns - 1].IsVisible = false;
            
            this.CategoryRadGridView.MasterGridViewTemplate.BestFitColumns();
        }

        public void EndEdit()
        {
            this.CategoryRadGridView.EndEdit();
            this.CategoryBindingSource.EndEdit();
        }
    }
}
